!******************************************************************
! Matrix
! Vladimir V. Chukin (chukin@rshu.ru)
! 01.04.2009
!******************************************************************

program main
  implicit none
  integer :: n = 1
  character(len=10) :: args
  integer :: i, j
  integer, parameter :: s = 30
  integer, dimension (s,s) :: m1
  integer, dimension (s,s) :: m2
  integer, dimension (s,s) :: mm

  if(iargc()==1) then
   call getarg(1, args)
   read(args,*) n
  end if

  call mkmatrix(s, s, m1)
  call mkmatrix(s, s, m2)

  do i = 1, n
   call mmult(s, s, m1, m2, mm)
  end do

  write(*,*) mm(1,1), mm(3,4), mm(4,3), mm(5,5)

end program main



subroutine mkmatrix(rows, cols, m)
  implicit none
  integer, intent(in) :: rows, cols
  integer, intent(inout) :: m(rows, cols)
  integer, save :: i, j, con

  con = 1
  do i = 1, rows
    do j = 1, cols
     m(i,j) = con
     con = con + 1
    end do
  end do

end subroutine mkmatrix



subroutine mmult(rows, cols, m1, m2, m3)
  integer, intent(in) :: rows, cols, m1(rows, cols), m2(rows, cols)
  integer, intent(inout) :: m3(rows, cols)
  integer :: var
  integer :: i, j, k

        var = 0
	do i = 1, rows
	    do j = 1, cols
		val = 0
		do k = 1, cols
		    val = val + m1(i,k)*m2(k,j)
		end do
		m3(i,j) = val
	    end do
	end do

end subroutine mmult
